//
//  JViewTestViewController.m
//  JViewTest
//
//  Created by James Gamble on 20/05/2010.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

#import "JViewTestViewController.h"

@implementation JViewTestViewController

@dynamic img_squareTiles;

/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/



// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	
	img_squareTiles[1]=[UIImage imageNamed:@"squareTile.png"]; // Loads image into Variable
	img_squareTiles[2]=[UIImage imageNamed:@"squareTile2.png"]; // Loads image into Variable

	finger=[[UIView alloc] initWithFrame:CGRectMake(0,0,320,480)];
	
	int x=0;
	int y=0;
	for (int n=0;n<140;n++) {
		gameGrid[n]=0;
		
		viewGrid[n]=[[UIImageView alloc] initWithImage:img_squareTiles[1]]; // Make viewGrid a ImageView using squareTile as the default image.
		viewGrid[n].frame=CGRectMake(x*32,y*32,32,32);		// Give it an X/Y co-ordinate and width/height
		[self.view addSubview:viewGrid[n]];  // then add that into the overall view
		
		x++; if (x==10) {x=0;y++;}     // Shift the X/Y
	}
	
	[NSTimer scheduledTimerWithTimeInterval:(0.033) target:self selector:@selector(perFrame) userInfo:nil repeats:YES]; // .033 seconds = approx 30 frames per second.
}

// Gets called 30 times per second.
- (void)perFrame {
	
	if (fingerDown==1) {  // If onscreen
		int x=floor((fingerPoint.x/32));  // Get grid x
		int y=floor(((fingerPoint.y-24)/32)); // Get grid y  (note, the y position still seems to count the top bar, so we -24 to account for that.)
		
		if (x>-1 && x<10 && y>-1 && y<14) {
			fingerDown=0;   // Switch off fingerDown, since we only need a single tap..
			
			int ID=y*10+x;	// And all of this stuff is the same as it was..
			gameGrid[ID]=1-gameGrid[ID];
			if (gameGrid[ID]==1) {viewGrid[ID].image=img_squareTiles[2];}
			if (gameGrid[ID]==0) {viewGrid[ID].image=img_squareTiles[1];}
		}
	}
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

// Touchyness!
- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {
	fingerPoint = [[touches anyObject] locationInView:finger];
	fingerDown=1;
}
- (void)touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event {
	fingerPoint = [[touches anyObject] locationInView:finger];
	fingerDown=2;
}
- (void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event {
	fingerPoint = [[touches anyObject] locationInView:finger];
	fingerDown=0;
}


- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[*img_squareTiles dealloc]; // Clears it when we quit.
	
    [super dealloc];
}

@end
